<?php
SPEXOR_preSetup();        // ONLY REQUIRED FOR INITIAL RUN
SPEXOR_requestToken();    // INCLUDES INITIAL AUTHENTIFICATION AND TOKEN HANDLING (REFRESH)
SPEXOR_deviceInfo();      // LIST DEVICE(S) AND SENSOR READINGS
// SPEXOR_registerWebhook("<HTTPS_WEBHOOK>",array("DeviceStatus","Burglary","Temperature","Test"));
// SPEXOR_deleteWebhook("<WEBHOOK_ID>");
// SPEXOR_listWebhooks();
// SPEXOR_setAlarm("<DEVICE_ID>",<0|1>);


function SPEXOR_setAlarm($id,$bool) {
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $bearer=GetValue(IPS_GetVariableIDByName("access_token",$CatID));
    if ($bool) { $mode="Activated";}
    else { $mode="Deactivated";}
    $access_token=GetValue(35111);
    $data = '[{"observationType": "Burglary", "sensorMode": "'.$mode.'"}]';
    $url = "https://api.spexor-bosch.com";
    $headers = array("Authorization: Bearer $bearer",'Content-Type: application/json');
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_URL, $url."/api/public/v1/spexor/$id/status/observation"); #?observationType=Burglary&sensorMode=Activated");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    $response = curl_exec($ch);
    print_r(json_decode( $response));
}

function SPEXOR_listWebhooks() {

    $url_base = 'https://api.spexor-bosch.com';
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $bearer=GetValue(IPS_GetVariableIDByName("access_token",$CatID));

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer $bearer"));
    curl_setopt($ch, CURLOPT_POST, false);
    curl_setopt($ch, CURLOPT_URL,$url_base."/api/public/v1/webhooks?client_id=spexor-3rdparty-service-auth");
    $result = curl_exec($ch);
    $json = json_decode($result, true);
    print_r($json);
  
}
function SPEXOR_deleteWebhook($id) {

    $url_base = 'https://api.spexor-bosch.com';  
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $bearer=GetValue(IPS_GetVariableIDByName("access_token",$CatID));

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer $bearer"));
    curl_setopt($ch, CURLOPT_URL,$url_base."/api/public/v1/webhooks/$id");
    $result = curl_exec($ch);

    curl_close($ch);
    $json = json_decode($result, true);
    print_r($json);
  
}

function SPEXOR_registerWebhook($url,$alerts) {
    $events="";
    foreach ($alerts as $a) { $events.="\"$a\",";}
    $events=rtrim($events,",");
    $data = '{"url": "'.$url.'", "events": ['.$events.'] , "headers": { "key": "value"}}';

    $url_base = 'https://api.spexor-bosch.com';
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $bearer=GetValue(IPS_GetVariableIDByName("access_token",$CatID));

    $ch = curl_init();  
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer $bearer","Content-Type: application/json"));
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_URL,$url_base."/api/public/v1/webhooks");
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  
    $result = curl_exec($ch);
    $json = json_decode($result, true);
    print_r($json);

}

function SPEXOR_SensorInfo($id) {
    $url_base = 'https://api.spexor-bosch.com';
    
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $bearer=GetValue(IPS_GetVariableIDByName("access_token",$CatID));
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer $bearer"));
    curl_setopt($ch, CURLOPT_POST, FALSE);
    curl_setopt($ch, CURLOPT_URL,$url_base."/api/public/v1/spexor/$id/sensor?keys=Microphone,PassiveInfrared,Fire,AirQuality,AirQualityLevel,Temperature,Pressure,Acceleration,Light,Humidity&client_id=spexor-3rdparty-service-auth"); 
 
    $result = curl_exec($ch);
    $json = json_decode($result, true);
    print_r($json);
}

function SPEXOR_deviceInfo() {
    $url_base = 'https://api.spexor-bosch.com';
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $bearer=GetValue(IPS_GetVariableIDByName("access_token",$CatID));
    if (!$bearer){ return 1;} 
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer $bearer"));
    curl_setopt($ch, CURLOPT_POST, FALSE);
    curl_setopt($ch, CURLOPT_URL,$url_base."/api/public/v1/spexors?client_id=spexor-3rdparty-service-auth");

    $result = curl_exec($ch);
    $json = json_decode($result, true);
    if ($json[0]['name']) {
        print "Looks good, we have access to a device named '".$json[0]['name']."' and this is what we know about it:\n";
    }
    print_r($json);
    print "Some sensor readings...\n";
    SPEXOR_SensorInfo($json[0]['id']);
}



function SPEXOR_preSetup() {
    if  (@IPS_GetCategoryIDByName("SPEXOR",0)) {  return 1;}
    print "Creating Category \"SPEXOR\" and some variables...\n";
    $CatID=IPS_CreateCategory();
    IPS_SetName($CatID, "SPEXOR");

    $VarID = IPS_CreateVariable(3);
    IPS_SetName($VarID, "device_id"); // Variable benennen
    IPS_SetParent($VarID, $CatID);

    $VarID= IPS_CreateVariable(3);
    IPS_SetName($VarID, "access_token"); // Variable benennen
    IPS_SetParent($VarID, $CatID);

    $VarID = IPS_CreateVariable(3);
    IPS_SetName($VarID, "refresh_token"); // Variable benennen
    IPS_SetParent($VarID, $CatID);

    $VarID = IPS_CreateVariable(3);
    IPS_SetName($VarID, "user_id"); // Variable benennen
    IPS_SetParent($VarID, $CatID);
}

function SPEXOR_checkToken() {
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $tmp=IPS_GetVariable(IPS_GetVariableIDByName("access_token",$CatID));
    if ((time() - $tmp["VariableUpdated"])>3590) {
        SPEXOR_refreshToken();
    }
}

function SPEXOR_refreshToken() {
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
  
    $url_base = 'https://api.spexor-bosch.com';
    $access_token=GetValue(IPS_GetVariableIDByName("access_token",$CatID));
    $refresh_token=GetValue(IPS_GetVariableIDByName("refresh_token",$CatID));
    
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer $access_token"));
    curl_setopt($ch, CURLOPT_POST, TRUE);
    curl_setopt($ch, CURLOPT_URL,$url_base."/api/public/refresh?client_id=spexor-3rdparty-service-auth&refresh_token=$refresh_token");

    $result = curl_exec($ch);
    curl_close($ch);
    $json = json_decode($result, true);

    SetValue(IPS_GetVariableIDByName("access_token",$CatID),$json["access_token"]);
    SetValue(IPS_GetVariableIDByName("refresh_token",$CatID),$json["refresh_token"]);
    IPS_LogMessage("SPEXOR","Refreshed token");
}

function SPEXOR_requestToken() {
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $access_tokenID=IPS_GetVariableIDByName("access_token",$CatID);
    if (GetValue($access_tokenID)) {
        SPEXOR_checkToken();
        return 1;
    }
    $url_base = 'https://api.spexor-bosch.com';
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $DeviceID=IPS_GetVariableIDByName("device_id",$CatID);
    if (!GetValue($DeviceID)) {
        print "Seems you need to register first...\n\n";
        SPEXOR_register(); return;
    }
    $ID_acctoken=IPS_GetVariableIDByName("access_token",$CatID);
    $ID_reftoken=IPS_GetVariableIDByName("refresh_token",$CatID);
    $device_code=GetValue($DeviceID);
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_URL,$url_base."/api/public/token?client_id=spexor-3rdparty-service-auth&device_code=$device_code");

    $result = curl_exec($ch);
    curl_close($ch);
    $json = json_decode($result, true);
//    print_r($json);
    if (@$json["error"] == "authorization_pending") {
        print "Seems you still need to register your user code with the SPEXOR APP.\n";
        SPEXOR_register(); return 1;
    }
   SetValue($ID_acctoken,$json["access_token"]);
   SetValue($ID_reftoken,$json["refresh_token"]);
}

function SPEXOR_register() {
    $url_base = 'https://api.spexor-bosch.com';

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_URL,$url_base."/api/public/auth?client_id=spexor-3rdparty-service-auth");
    $result = curl_exec($ch);
    $json = json_decode($result, true);
   // print_r($json);
    print "Your user code is: <B>".$json['user_code']."</B>\n";
    print "Open SPEXOR APP and proceed to [Account] -> [Externe Services] -> [+] to register.\n";
    print "Name: IPS // Code: ".$json['user_code']."\n";
    $CatID=IPS_GetCategoryIDByName("SPEXOR",0);
    $DeviceID=IPS_GetVariableIDByName("device_id",$CatID);
    $UserID=IPS_GetVariableIDByName("user_id",$CatID);
    SetValue($DeviceID,$json["device_code"]);
    SetValue($UserID,$json["user_code"]);
}